// STexture.h: Schnittstelle fr die Klasse STexture.
//
// Copyright by Andr Stein
// E-Mail: andre_stein@gmx.de, andre_stein@web.de
// http://www.steinsoft.net
//////////////////////////////////////////////////////////////////////

#ifndef S_BMP_TEXTURE_H
#define S_BMP_TEXTURE_H

#ifdef WIN32
#include <windows.h>
#endif

#include <GL/gl.h>
#include <GL/glu.h>

class SBMPTexture
{
public:
	void destroy();
	
	/////////////
	// Konstruktoren
	///////////////
	SBMPTexture();
	SBMPTexture(const char* filename,int minFilter = GL_LINEAR,
		int magFilter = GL_LINEAR, bool clampToEdge = false);


        virtual ~SBMPTexture();
	
	/////////////////
	// Funktionen
	////////////////

	virtual bool createMipmap(const char* filename,int minFilter = GL_LINEAR_MIPMAP_NEAREST,
		int magFilter = GL_LINEAR, bool clampToEdge = false);
	virtual bool createTexture(const char* filename, int minFilter = GL_LINEAR,
		int magFilter = GL_LINEAR, bool clampToEdge = false);
	
	void select();

	GLuint getGLTexture();
protected:
	GLuint texture;
};

#endif 
