// SObjects.cpp: Implementierung der Klasse SObjects.
//
//////////////////////////////////////////////////////////////////////

#include "sobjects.h"

#include <GL/gl.h>

#define XW 1.0f
#define YW 1.0f
#define Z  1.0f

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

SObjects::SObjects()
{
	quadric = 0;
	inited = false;
}

SObjects::~SObjects()
{
	if (inited)
	{
		gluDeleteQuadric(quadric);
	}
}

void SObjects::init()
{
	if (inited)
	{
		return;
	}

	quadric = gluNewQuadric();
	gluQuadricNormals(quadric,GLU_SMOOTH);

	inited = true;
}

void SObjects::draw(bool white)
{
	if (!inited)
	{
		init();
	}

	//*******************
	// QUAD
	//*******************

	glPushMatrix();

	glTranslatef(-2.0f,4.0f,-13.0f);
	
	glBegin(GL_QUADS);
			if (!white)
			{
				glColor3f(0.0f,0.0f,1.0f);
			}
			else
			{
				glColor3f(1.0f,1.0f,1.0f);
			}
			// BACK
			glNormal3f(0.0f,0.0f,1.0f);
			glVertex3f(XW,YW,-Z);
			glVertex3f(-XW,YW,-Z);
			glVertex3f(-XW,-YW,-Z);
			glVertex3f(XW,-YW,-Z);

			//LEFT
			glNormal3f(-1.0f,0.0f,0.0f);
			glVertex3f(-XW,YW,-Z);
			glVertex3f(-XW,YW,Z);
			glVertex3f(-XW,-YW,Z);
			glVertex3f(-XW,-YW,-Z);

			//RIGHT
			glNormal3f(1.0f,0.0f,0.0f);
			glVertex3f(XW,YW,-Z);
			glVertex3f(XW,-YW,-Z);
			glVertex3f(XW,-YW,Z);
			glVertex3f(XW,YW,Z);

			//TOP
			glNormal3f(0.0f,1.0f,0.0f);
			glVertex3f(XW,YW,-Z);
			glVertex3f(-XW,YW,-Z);
			glVertex3f(-XW,YW,Z);
			glVertex3f(XW,YW,Z);

			//BOTTOM
			glNormal3f(0.0f,-1.0f,0.0f);
			glVertex3f(XW,-YW,-Z);
			glVertex3f(-XW,-YW,-Z);
			glVertex3f(-XW,-YW,Z);
			glVertex3f(XW,-YW,Z);

			//FRONT
			glNormal3f(0.0f,0.0f,1.0f);
			glVertex3f(XW,YW,Z);
			glVertex3f(-XW,YW,Z);
			glVertex3f(-XW,-YW,Z);
			glVertex3f(XW,-YW,Z);
		glEnd();
	
	glPopMatrix();

	//*******************
	// SPHERE
	//*******************

	glPushMatrix();
	
	glTranslatef(4.0f,-4.0f,-15.0f);
	gluSphere(quadric,XW,30,30);
	
	glPopMatrix();
	
	//*******************
	// BOARD
	//*******************

	glPushMatrix();

	glTranslatef(-1.5f,-5.0f,-16.0f);
	
	glBegin(GL_QUADS);
		glNormal3f(0.0f,1.0f,0.0f);
		glVertex3f(0.0f,0.0f,0.0f);
		glVertex3f(-2.5f,0.0f,0.0f);
		glVertex3f(-2.5f,2.5f,-4.0f);
		glVertex3f(0.0f,2.5f,-4.0f);
	glEnd();

	glPopMatrix();
	
}
